export declare abstract class Common {
    ios: any;
    android: any;
    config: any;
    constructor(databaseName: string);
    abstract createDocument(data: Object, documentId?: string): any;
    abstract getDocument(documentId: string): any;
    abstract updateDocument(documentId: string, data: any): any;
    abstract deleteDocument(documentId: string): any;
    abstract destroyDatabase(): any;
    abstract query(select?: any[]): QueryBase;
    abstract createPullReplication(remoteUrl: string): any;
    abstract createPushReplication(remoteUrl: string): any;
    abstract addDatabaseChangeListener(callback: any): any;
}
export declare abstract class ReplicatorBase {
    replicator: any;
    constructor(replicator: any);
    abstract start(): any;
    abstract stop(): any;
    abstract isRunning(): any;
    abstract setContinuous(isContinuous: boolean): any;
}
export declare enum QueryMeta {
    ID = "COUCHBASE_ID",
}
export interface CBQuery {
    query: any;
    execute(): any[];
}
export interface QueryBase extends CBQuery {
    query: any;
    database: Common;
    from(databaseName?: string): QueryFromBase;
}
export interface QueryFromBase {
    constructor(databaseName: string, query: QueryBase): any;
    where(): QueryWhereBase;
    orderBy(): QueryOrderByBase;
    groupBy(): QueryGroupByBase;
    join(): QueryJoinBase;
}
export interface QueryWhereBase {
    constructor(query: any): any;
    orderBy(): QueryOrderByBase;
    groupBy(): QueryGroupByBase;
    limit(): QueryLimitBase;
}
export interface QueryOrderByBase {
    limit(): QueryLimitBase;
    execute(): any[];
}
export interface QueryGroupByBase {
    limit(): QueryLimitBase;
    execute(): any[];
}
export interface QueryLimitBase {
    constructor(limit: number): any;
    limit: number;
}
export interface QueryJoinBase {
    constructor(query: any): any;
    where(): QueryWhereBase;
    orderBy(): QueryOrderByBase;
    limit(): QueryLimitBase;
}
export declare type QueryExpressionType = 'modulo' | 'is' | 'between' | 'isNot' | 'collate' | 'in' | 'add' | 'isNullOrMissing' | 'greaterThan' | 'divide' | 'notEqualTo' | 'greaterThanOrEqualTo' | 'like' | 'subtract' | 'and' | 'or' | 'lessThanOrEqualTo' | 'lessThan' | 'notNullOrMissing' | 'regex' | 'equalTo' | 'multiply';
export interface QueryExpressionItem {
    property: any;
    value: any | any[];
    type: QueryExpressionType;
}
export interface QueryExpressionBase {
    expression: QueryExpressionItem[];
    modulo(property: string, value: any): this;
    is(property: string, value: any): this;
    between(propertyA: string, valueA: any, propertyB: string, valueB: any): this;
    isNot(property: string, value: any): this;
    in(param0: any[]): this;
    add(property: string, value: any): this;
    isNullOrMissing(): this;
    greaterThan(property: string, value: any): this;
    divide(property: string, value: any): this;
    notEqualTo(property: string, value: any): this;
    greaterThanOrEqualTo(property: string, value: any): this;
    like(property: string, value: any): this;
    subtract(property: string, value: any): this;
    and(property: string, value: any): this;
    or(property: string, value: any): this;
    lessThanOrEqualTo(property: string, value: any): this;
    lessThan(property: string, value: any): this;
    notNullOrMissing(): this;
    regex(property: string, value: any): this;
    equalTo(property: string, value: any): this;
    multiply(property: string, value: any): this;
}
